classdef CLevelMeter < handle
    %CLEVELMETER  NiHu.Lab class for level meter
    
    properties (SetAccess = private)
        Channels
    end
    
    properties (SetObservable = true)
        Levels
        Peaks
    end
    
    methods
        function obj = CLevelMeter(channels)
            %CLEVELMETER constructor
            
            obj.Channels = channels;
            obj.Reset();
        end
        
        function UpdateLevels(obj, data)
            %UPDATELEVELS update levels
            
            chsel = cell2mat({obj.Channels.isSelected});
            obj.Levels(chsel) = max(abs(data), [], 1);
            obj.Peaks = max(obj.Peaks, obj.Levels);
        end
        
        function ResetPeaks(obj)
            %RESETPEAKS reset level meter peaks
            
            obj.Peaks = obj.Levels;
        end
        
        function Reset(obj)
            %RESET reset level meter
            
            obj.Levels = zeros(1, length(obj.Channels));
            obj.ResetPeaks();
        end
    end % methods
end % classdef
