classdef CStreamerView < CGuiView & CBlockablePanel
    %CSTREAMERVIEW NiHu.Lab panel for controlling the CStreamer module
    
    methods
        function obj = CStreamerView(parent, hData)
            obj = obj@CBlockablePanel(parent, 'TWITTER_PANEL');
            obj = obj@CGuiView(hData, {});
            obj.InitObject();
            obj.refresh();
        end
        
        function refresh(obj)
            %REFRESH function called when data object has changed
        end
        
        function TwitCallback(obj, src)
            obj.hData.AddTwit(get(src, 'String'));
            set(src, 'String', '');
        end
    end % of public methods
    
    methods (Access = private)
        function InitObject(obj)
            hTwit = uicontrol('Parent', obj.hPanel, ...
                'Style', 'Edit', ...
                'Callback', @(src,event)TwitCallback(obj, src), ...
                'HorizontalAlignment', 'left');
            GuiLayout.ApplyLayout(obj.hPanel, {{hTwit, [-1 0]}});
        end
    end % of private methods
end % of classdef
