classdef CTimeElapsedView < CGuiView & CPanel
    %CTIMEELAPSEDVIEW View class of CTimeElapsed
    %
    % See also: CTimeElapsed, CRecord

    properties
        hText      % text where the information is displayed
    end
    
    methods
        function obj = CTimeElapsedView(parent, hData)
            obj = obj@CPanel(parent, 'TIME_ELAPSED_PANEL');
            obj = obj@CGuiView(hData, {'TimeElapsed'});
            obj.InitObject();
            obj.refresh();
        end
        
        function refresh(obj)
            dv = datevec(obj.hData.TimeElapsed/60/60/24);
            set(obj.hText, 'String', sprintf('%d h %.2d m %05.2f s', dv(4:6)));
        end
    end
    
    methods (Access = private)
        function InitObject(obj)
            obj.hText = uicontrol('Parent', obj.hPanel, 'Style', 'text', ...
                'string', '0 s', ... % dummy for extent
                'Position', [0, 0, CSetupClass.itemWidth, CSetupClass.itemHeight]);
            e = get(obj.hText, 'extent');
            p = get(obj.hText, 'position');
            p(4) = e(4);
            set(obj.hText, 'position', p);
            GuiLayout.ApplyLayout(obj.hPanel, {{obj.hText, [-1 0]}});
        end
    end
end
