#include "Amplifier.h"
#include "Calibrator.h"
#include "Pool.hpp"
#include "Sensor.h"

#include <iostream>

int main()
{
	try
	{
		CPool<CCalibrator> CP("data/Calibrators.txt");
		std::cout << CP << std::endl;
		CPool<CAmplifier> AP("data/Amplifiers.txt");
		std::cout << AP << std::endl;
		CPool<CSensor> SP("data/Sensors.txt");
		std::cout << SP << std::endl;
	}
	catch (const char *c)
	{
		std::cerr << c << std::endl;
	}

	return 0;
}
