function classdiagram(directory)

if nargin < 1
    directory = pwd;
end

files = dir(fullfile(directory, '*.m'));
k = 0;
for i = 1 : length(files)
    fid = fopen(fullfile(directory, files(i).name), 'rt');
    c = textscan(fid, '%s', 'delimiter', '\n');
    fclose(fid);
    c = c{1};
    key = 'classdef';
    c = c(strncmp(c, key, length(key)));
    if ~isempty(c)
        n = regexp(c, 'classdef\s+(?<classname>\w+)\s*<*\s*(?<anc1>\w*)\s*&*\s*(?<anc2>\w*)', 'names');
        k = k + 1;
        S(k) = n{1};
    end
end
S = struct2cell(S(:))';
externals = setdiff(setdiff(union(S(:,2),S(:,3)),S(:,1)), {''});
classes = [S(:,1); externals];
C = zeros(length(classes),2);

for j = 1 : 2
    [~, C(1:size(S,1),j)] = ismember(S(:,j+1), classes);
end

n = size(C,1);
level = zeros(n,1);
p = 0;
l = 0;
while ~all(level)
    new = setdiff(find(all(ismember(C,p),2)), p);
    l = l + 1;
    level(new) = l;
    p = union(p, new);
end

pos = zeros(n,1);
pos(level == 1) = 1 : length(find(level == 1));
for l = 1 : max(level)-1
    p = 0;
    for i = 1 : n
        if level(i) ~= l
            continue;
        end
        sons = find(any(C==i,2) & ~pos);
        pos(sons) = p + (1:length(sons));
        p = p + length(sons);
    end
end

y = level;% + 0.05*mod(pos,2);
for l = 1 : max(level)
    i = level == l;
    x(i) = pos(i)/(max(pos(i))+1);
end

fig = figure('Color', 'white', 'MenuBar', 'none', 'NumberTitle', 'off', 'Name', 'Class Diagram');
axes('parent', fig, 'yDir', 'reverse', 'nextplot', 'replacechildren');
axis off;
plot(x, y, '.');
f = find(C(:,1));
ind = [C(f,1) f]';
line(x(ind), y(ind), 'LineWidth', 2);
f = find(C(:,2));
ind = [C(f,2) f]';
line(x(ind), y(ind), 'LineWidth', 2);

for i = 1 : n
    text(x(i), y(i), classes{i},...
        'BackGroundColor', 'blue', ...
        'Color', 'white', ...
        'FontWeight', 'bold', ...
        'FontSize', 8, ...
        'edgeColor', 'black', ...
        'HorizontalAlignment', 'center', ...
        'VerticalAlignment', 'middle',...
        'ButtonDownFcn', @(src,event)open(get(src, 'String')));
end
end
