% Copyright 2010-2010 Peter Fiala
clear all;
clc;

data = cell(1,15);

for p = 7 : 17
    disp(p);
    N0 = 2^p;
    
    Ntol = 0.1;
    Nvec = primes(N0*(1+Ntol))';
    Nvec = Nvec(Nvec > N0);

    A = zeros(ceil(N0/2*(1+Ntol)),length(Nvec));
    for i = 1 : length(Nvec)
        A(1:floor(Nvec(i)/2),i) = 1;
    end
    
    [q,N] = ind2sub(size(A), find(A));
    N = Nvec(N);
    z = q ./ N;
    [~, i] = unique(round(1200*log2(z)/2), 'first');
    data{p}.N = N(i);
    data{p}.q = q(i);
end

save NQ data
