classdef Scalar < Pivotable
    properties
        value
    end
    
    methods
        function this = Scalar(value, indices)
            this = this@Pivotable(indices);
            this.value = value;
        end
        
        function result = plus(this, theother)
            result = this;
            for i = 1 : numel(this)
                result(i).value = result(i).value+theother(i).value;
            end
        end
        
        function result = minus(this, theother)
            result = this;
            for i = 1 : numel(this)
                result(i).value = result(i).value-theother(i).value;
            end
        end
        
        function result = times(this, theother)
            result = this;
            if isnumeric(theother)
                for i = 1 : numel(this)
                    result(i).value = result(i).value*theother(min(end,i));
                end
            else
                for i = 1 : numel(this)
                    result(i).value = result(i).value*theother(min(end,i)).value;
                end
            end
        end
        
        function result = power(this, nums)
            result = this;
            for i = 1 : numel(this)
                result(i).value = result(i).value.^nums(min(i,end));
            end
        end
        
        function result = rdivide(this, theother)
            result = this;
            if isnumeric(theother)
                for i = 1 : numel(this)
                    result(i).value = result(i).value ./ theother(min(i,end));
                end
            else
                for i = 1 : numel(this)
                    result(i).value = result(i).value ./ theother(min(i,end)).value;
                end
            end
        end
    end
end