function [Center, Y3] = time2third(fs, y)

s = size(y);
N = s(1);
y = reshape(y, N, []);

y = fft(y, [], 1);
f = (0 : N-1)/N*fs;
f(f >= fs/2) = f(f>=fs/2)-fs;

Center = 1000 * 2.^(-100/3:1/3:100/3);
Center = Center';
low = Center/2^(1/6);
high = Center*2^(1/6);
nC = length(low);

filled = false(size(low));

Y3 = zeros(nC, size(y,2));

for iC = 1 : nC
    sel = abs(f) >= low(iC) & abs(f) < high(iC);
    if length(find(sel)) < 5
        continue;
    end
    
    Y3(iC,:) = sum(abs(y(sel,:)).^2, 1) / (N * fs);
    
    filled(iC) = true;
end

Y3 = Y3(filled, :);
Center = Center(filled);

s(1) = size(Y3,1);
Y3 = reshape(Y3, s);

Y3 = sqrt(Y3);

end
